.nolist             
   #include "ion.inc" 
   #include "Tasten.inc"
;_______________________________Definitionen:_____________________________________________________
#define Sameflags		(iy+Asm_Flag1)
#define Markieren		0
#define Loeschen		1
#define Fund			2

;_______________________________RAM-Variablen:___________________________________________________
#define Spielfeld		sram
#define CurX			sram+150
#define CurY			sram+151
#define Punktestand		sram+152 ;Wort
#define VZWort			sram+154 ;Wort
#define Groesse			sram+156
;______________________________________________________________________________________________
;_______________________________Hauptprogramm____________________________________________________
;______________________________________________________________________________________________
.list                
#ifdef TI83P            
   .org  progstart-2    
   .db   $BB,$6D       
#else                   
   .org  progstart  
#endif
 
   ret             
   jr    nc,start     
   .db   "AwSame v1.6",0
start:
 set textwrite, (iy+sgrflags)			;Text nur in den Bildschirmspeicher schreiben
 
HMenu:
 bcall(_grbufclr)
 ld a,12
 ld l,3
 ld b,11
 ld c,9
 ld ix,PLogo
 call ionlargesprite					;Logo anzeigen
 ld hl,256*21+22
 ld (pencol),hl
 ld hl, S2nd							;Mentexte
 bcall(_vPutS)
 ld hl,256*31+31
 ld (pencol),hl
 ld hl,SClear
 bcall(_vPutS)
 ld hl,256*45+29
 ld (pencol),hl
 ld hl,SRekord
 bcall(_vPutS)
 ld hl,(Rekord)
 bcall(_setXXXXOP2)
 bcall(_OP2toOP1)
 ld a,5
 bcall(_dispop1a)						;Rekord anzeigen
 ld hl,256*57+18
 ld (pencol),hl
 ld hl,SAuthor
 bcall(_vPutS)
 call ionfastcopy
 
MSchleife:
 bcall(_getCSC)
 cp sk2nd
 jr z,NeuesSpiel
 cp skClear
 ret z
 ld a, ResKB
 out (1),a
 ld a,Gr7
 out (1),a
 in a,(1)								;ber DirectInput nach gleichzeitigem Druck von Mode und Del prfen
 cp 63									;kMode AND kDel
 jr nz,MSchleife
 ld hl,0
 ld (Rekord),hl							;Rekord lschen
 jr HMenu

 
NeuesSpiel:
 ld hl,0
 ld (CurX),hl							;Cursorkoordinaten auf Startwerte setzen
 ld (Punktestand),hl					;Punktestand auf 0 setzen
 ld hl,Spielfeld
 ld b,150
NSchleife:
 push bc
 ld b,5
 call ionrandom
 pop bc
 inc a									;0 ausschlieen
 ld (hl),a								;Liste mit Zufallszahlen fr Spielfeld erstellen
 inc hl
 djnz NSchleife
 call ZeichneFeld
 
Spielschleife:
 bcall(_getCSC)							;Tasteneingaben
 or a
 jr z, Spielschleife					;bei keinem Tastendruck erneut suchen
 cp skClear
 jp z, HMenu
 cp skRechts
 jr z, CurRechts
 cp skLinks
 jr z, CurLinks
 cp skOben
 jr z, CurOben
 cp skUnten
 jr z, CurUnten
 cp sk2nd
 jr z, Klick
 cp skMode
 jp z,Pause
 jr Spielschleife
 
CurRechts:								;Cursorwerte verndern, sofern mglich
 ld a, (CurX)
 cp 14
 jr z, Spielschleife
 inc a
 jr LR
 
CurLinks:
 ld a, (CurX)
 or a
 jr z, Spielschleife
 dec a
LR:										;gemeinsame Operationen fr Links und Rechts
 push af
 call DrawCur							;alten Cursor lschen
 pop af
 ld (CurX),a
 call DrawCur
 jr Spielschleife
 
CurOben:
 ld a,(CurY)
 or a
 jr z, Spielschleife
 dec a
 jr OU
 
CurUnten:
 ld a,(CurY)
 cp 9
 jr z, Spielschleife
 inc a
OU:										;gemeinsame Operationen fr Oben und Unten
 push af
 call DrawCur							;alten Cursor lschen
 pop af
 ld (CurY),a
 call DrawCur
 jp Spielschleife
 
Klick:									;Spielzug-Operationen
 call Zellenwert
 ld a,(hl)								;Inhalt der Zelle=Vergleichswert
 or a
 jr z,Spielschleife						;keine Suche bei leerem Feld
 ld de,(CurX)
 push de								;Cursorwert sichern
 ld c,a
 ld Sameflags,1							;im ersten Suchschritt keine Felder lschen, aber markieren
 call Feldsuche
 set Loeschen,Sameflags
 xor a
 ld (Groesse),a							;Feldgre auf 0 setzen
Suchschleife:
 ld a,6
 call FindeZahl							;Nach markierter Zelle suchen
 jr nz,Zugende							;kein Fund ->Spielzug beendet, Feld bereinigen
 call Feldsuche
 jr Suchschleife
 
Zugende:
 ld a,(Groesse)
 ld l,a
 ld h,0
 dec a
 call HLmalA							;n*(n-1)
 ld de, (Punktestand)
 add hl,de
 ld (Punktestand),hl

CleanY:									;sucht nach gelschten Feldern und lsst Felder ber ihnen nach unten fallen
 ld a,7
 call FindeZahl							;nach Zelle mit Lschmarkierung suchen
 jr nz,CleanX							;Wenn keine Lschmarkierung mehr vorhanden, abbrechen
 call Cursorwert
 ld a,(CurY)
 or a									;Wenn Lschmarkierung in oberster Zeile, Markierung lschen
 jr nz,Vertauschen						;sonst mit oberem Feld vertauschen
 xor a
 ld (hl),a
 jr CleanY
Vertauschen:
 push hl
 ld de,15								;in obere Zeile springen
 and a
 sbc hl,de
 ld c,(hl)								;diesen Wert zwischenspeichern
 ld a,7
 ld (hl),a								;Lschmarkierung auf oberes Feld setzen
 pop hl									;ursprngliche Zeile
 ld (hl),c								;zwischengespeicherten Wert nach unten verschieben
 jr CleanY
 
CleanX:									;sucht nach leerer Spalte und verschiebt alle Spalten rechts von ihr nach links
 ld c,14								;maximal 14 Verschiebungen (falls linke Spalte leer)
 ld hl,Spielfeld+135					;erstes Feld in letzter Zeile	
CheckCol: 
 ld a,(hl)
 or a
 jr nz, NextCol							;kein leeres Feld: nchste Spalte prfen
 ld a,10								;alle 10 Zeilen scrollen
 push hl
ScrollX:
 push hl
 pop de									;hl auf de laden
 inc hl									;Zeiger auf Feld rechts daneben
 ld b,0
 push bc
 ldir									;c Zellen nach links verschieben
 pop bc
 dec hl
 ld (hl),b								;Feld in letzter Spalte lschen
 ld de,15
 and a
 sbc hl,de								;Zeiger auf obere Zeile
 and a
 sbc hl,bc								;richtige Adresse= hl-16-bc
 dec a
 jr nz,ScrollX							;obere Zeile scrollen
 pop hl
 dec hl									;gleiches Feld nochmals berprfen, da mehrere leere Spalten hintereinander sein knnen
NextCol:
 inc hl
 dec c
 jr nz, CheckCol
 
CheckFeld:
 ld hl,Spielfeld+149
 ld Sameflags,0							;weder lschen oder markieren
 ld b,150
CSchleife:
 push bc
 ld a,(hl)								;Vergleichswert
 or a
 jr z,CheckNext							;leeres Feld	berspringen
 ld c,a
 call Feldsuche							;jedes Feld nach Nachbarn untersuchen
CheckNext:
 dec hl
 pop bc
 bit Fund,Sameflags
 jr nz,Checkende						;wenn Feld mit Nachbar gefunden, Suche beenden
 djnz CSchleife
 
Spielende:
 pop de									;Stack richtigstellen
 call ZeichneFeld						;Feld nochmals zeichnen
 ld hl,65535
Verz:
 ld de,1
 sbc hl,de
 jr nz,Verz								;Verzgerung
 bcall(_clrLCDF)						;Bildschirm lschen

 ld hl,(Rekord)							;Punktestand laden
 ld de,(Punktestand)
 and a
 sbc hl,de
 jp m, NeuerRekord
 ld hl,SEnde
 jr DispText							;Text, wenn kein neuer Rekord vorhanden
NeuerRekord:
 ld (Rekord),de							;alten Rekord durch neuen ersetzen
 ld hl,SNRekord
DispText:
 ld bc,256*3+2							;Text anzeigen, abhngig davon, ob ein neuer Rekord vorliegt oder nicht
 ld (currow),bc
 bcall(_PutS)
 ld hl,256*1+4
 ld (currow),hl
 ld hl,(Punktestand)
 bcall(_disphl)							;Punktestand anzeigen
 ld hl,SPunkte
 bcall(_PutS)
 
Wait:
 bcall(_getCSC)
 or a
 jr z,Wait
 jp HMenu								;zum Hauptmen zurckkehren
 
 
Checkende:
 pop de
 ld (CurX),de							;Cursorwert wiederherstellen
 call ZeichneFeld
 jp Spielschleife

 
;______________________________________________________________________________________________
;______________________________  Routinen:________________________________________________________
;______________________________________________________________________________________________
DrawCur:	;(zeigt den Cursor an)
 ld a,(CurY)
 ld hl,6
 call HLmalA
 inc l							;Y-Wert=6*Zeilenwert+1
 push hl
 ld a,(CurX)
 ld hl,6
 call HLmalA
 ld a,l
 add a,2							;X-Wert=6*Zeilenwert+2
 ld b,7
 ld ix, PCursor
 pop hl
 call ionputsprite
 call ionfastcopy
 ret
 
;______________________________________________________________________________________________
Zellenwert:	;(Gibt in hl die Adresse aus, an der sich der Cursor befindet. Zerstrt: af,de,hl)
 push bc
 ld a,(CurY)
 ld hl,15							;Y-Wert mit 15 multiplizieren
 call HLmalA
 ld e,l								;auf e zwischenspeichern
 ld a,(CurX)
 add a,e							;X-Wert addieren
 ld e,a
 ld d,0
 ld hl,Spielfeld
 add hl,de							;Spielfeld+Cursorwert=endgltige Adresse
 pop bc
 ret
;______________________________________________________________________________________________
Cursorwert:	;(Wandelt die Adresse in hl in entsprechende Cursordaten um. Zerstrt: af,de)
 push hl							;Speicherstelle sichern
 ld de,sram
 and a
 sbc hl,de							;Differenz von Cursorwert und SRam
 ld a,15
 bcall(_divHLbyA)
 ld (CurX),a						;Rest der Division:X-Wert
 ld a,l
 ld (CurY),a						;Divisionsergebnis:Y-Wert
 pop hl
 ret

;______________________________________________________________________________________________
Feldsuche:
 push hl							;urspr. Adresse sichern
 call Cursorwert					;Cursorwert fr Speicherstelle erstellen
 ld a,(CurX)
FLinks:
 dec hl								;Feld links
 or a
 jr z,FRechts						;nur linkes Feld vergleichen, wenn X>0 ist
 call Vergleich
FRechts:
 inc hl
 inc hl								;Feld rechts
 cp 14								;nur rechtes Feld vergleichen, wenn X<14 ist
 jr z,FOben
 call Vergleich
FOben:
 ld de,16
 and a
 sbc hl,de							;Feld oben
 ld a,(CurY)
 or a								;nur oberes Feld vergleichen, wenn Y>0 ist
 jr z,FUnten
 call Vergleich
FUnten:
 cp 9								;nur unteres Feld vergleichen, wenn Y<9 ist
 jr z,FEnde
 ld de,30							;Feld unten
 add hl,de
 call Vergleich
FEnde:
 pop hl								;Adresse wiederherstellen
 bit Loeschen,Sameflags
 ret z								;wenn nicht erwnscht, Zelle nicht lschen
 ld a,7
 ld (hl),a							;Lschmarkierung auf mittleres Feld setzen	
 ld a,(Groesse)
 inc a								;Feldgre erhhen
 ld (Groesse),a
 ret
 
;______________________________________________________________________________________________
Vergleich:	;(vergleicht a mit c und ldt bei gleichen Zahlen Markierung auf (hl)). 
 push af
 ld a,(hl) 
 cp c
 jr nz, VEnde
 bit Markieren,Sameflags			;Markierung nur setzen, wenn entspr. Flag gesetzt
 jr nz,Mark
 set Fund,Sameflags					;sonst nur auf Fund hinweisen
 jr VEnde
Mark:
 ld a,6								;Markierung setzen
 ld (hl),a
VEnde:
 pop af
 ret
 
;______________________________________________________________________________________________
FindeZahl:	;(sucht Spielfeld nach erstem Vorkommen der Zahl a ab Adresse hl ab. hl:gefundene Speicherstelle. Zerstrt:af)
 push bc
 ld hl,Spielfeld
 ld bc,150
 cpir
 dec hl
 pop bc
 ret
;________________________________________________________________________________________________
Pause: ;(schaltet den Rechner aus. Zerstrt: a)
 di									;Timer und sonstige Interrupts ausschalten
 ld a,1
 out (3),a							;Bildschirm ausschalten
 ei
 halt								;Verzgerung fr Tastatur
 jp Spielschleife
;______________________________________________________________________________________________
;______________________________  Subroutinen:______________________________________________________
;______________________________________________________________________________________________

AmodB:	;(Eingabe: a,b. Ausgabe: m: Rest; p: kein Rest. Zerstrt: bc)
 ld c,a
ModLoop:
 sub b
 jp m,ModEnde						;Wenn Vorzeichenflag gesetzt ist, existiert ein Rest fr A mod B 
 jr nz,ModLoop
ModEnde:
 ld a,c
 ret
;______________________________________________________________________________________________ 
HLmalA:		;(Eingabe: hl, a. Ausgabe: hl=hl*a. Zerstrt: af, hl, de)
 or a
 jr z, Null							;Wenn b=0, hl auf 0 setzen
 push hl
 pop de								;de auf hl laden
MLoop:
 dec a
 jr z, MEnde
 and a
 adc hl, de 
 jp pe,MEnde
 jr MLoop
Null:
 ld hl, 0
 inc a								;verhindern, dass das P/O-Flag auf ungltiges Ergebnis hinweisen wrde
MEnde:
 ret
 
;______________________________________________________________________________________________
ZeichneFeld:	;(zeichnet Spielfeld)
 bcall(_grbufclr)
 ld l,56
 ld bc, Spielfeld+149					;erste Speicherstelle
YSchleife:
 ld a,87
XSchleife:
 push af								;X-Wert sichern
 ld a,(bc)
 or a									;bei 0 kein Sprite zeichnen
 jr nz, Check1
 pop af									;X-Wert wiederherstellen (Stack-Berichtigung)
 jr NextX
Check1:
 cp 1
 jr nz, Check2
 ld ix, PSame1
 jr PutTile
Check2:
 cp 2
 jr nz, Check3
 ld ix, PSame2
 jr PutTile
Check3:
 cp 3
 jr nz, Check4
 ld ix, PSame3
 jr PutTile
Check4:
 cp 4
 jr nz, Check5
 ld ix, PSame4
 jr PutTile
Check5:
 ld ix, PSame5
PutTile:							;Feld anzeigen
 pop af
 push af
 push hl
 push bc
 ld b,5
 call ionputsprite
 pop bc
 pop hl
 pop af
NextX:
 dec bc								;nchste Speicherstelle
 sub 6								;nchster X-Wert
 jp p, XSchleife
 ld a,l
 sub 6								;nchster Y-Wert
 ld l,a
 jp p, YSchleife
 call DrawCur
 ret
 
;_______________________________________________________________________________________________
;_______________________________Statische Variablen:_________________________________________________
;_______________________________________________________________________________________________
;1. Zahlen:
Rekord:
 .db 0,0

;2. Strings:
SEnde:
 .db "Game over!",0
SNRekord:
 .db "New record!",0
SPunkte:
 .db " Points",0
S2nd:
 .db "2nd: Start game",0
SClear:
 .db "Clear: Quit",0
SRekord:
 .db "Record:",0
SAuthor:
 .db "2010 David Kulicke",0
;3. Sprites:
PSame1:
 .db %11011000
 .db %11011000
 .db %00100000
 .db %11011000
 .db %11011000

PSame2:
 .db %11111000
 .db %11111000
 .db %11111000
 .db %11111000
 .db %11111000
 
PSame3:
 .db %10101000
 .db %01010000
 .db %10101000
 .db %01010000
 .db %10101000
 
PSame4:
 .db %11111000
 .db %10001000
 .db %10101000
 .db %10001000
 .db %11111000
 
PSame5:
 .db %01110000
 .db %11111000
 .db %11011000
 .db %11111000
 .db %01110000

PCursor:
 .db %11111110
 .db %10000010
 .db %10000010
 .db %10000010
 .db %10000010
 .db %10000010 
 .db %11111110
 
PLogo:
 .db %11011000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000100
 .db %11011000,%00011000,%00000000,%00000011,%11100000,%00000000,%00000000,%00000011,%00001110
 .db %00100000,%00011000,%00000000,%00001100,%00100000,%00000000,%00000000,%00000011,%00011111
 .db %11011000,%00101000,%00000000,%00001000,%00000000,%00000000,%00000000,%01100010,%00001110
 .db %11011000,%00101100,%01000110,%00101000,%00000011,%00001000,%00110000,%10100110,%00000100
 .db %00000000,%01100100,%01000100,%01000111,%00000110,%10001011,%00101001,%01000110,%00000000
 .db %10101000,%01001100,%01001100,%01000000,%11000100,%10011101,%01001001,%11000110,%00011111
 .db %01010000,%11110110,%01001010,%10000000,%01001001,%10011001,%01001001,%00010000,%00010001
 .db %10101001,%10000010,%00110010,%10000000,%10001010,%10011001,%10001101,%00100100,%00010101
 .db %01010001,%00000001,%00110001,%10001111,%00001100,%11010001,%10000000,%11000000,%00010001
 .db %10101000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011111
.end
.END